=== modified file 'drizzled/definitions.h'
--- drizzled/definitions.h	2009-06-25 18:55:43 +0000
+++ drizzled/definitions.h	2009-06-27 16:33:55 +0000
@@ -790,8 +790,7 @@
 
 enum enum_schema_tables
 {
-  SCH_CHARSETS= 0,
-  SCH_COLLATIONS,
+  SCH_COLLATIONS= 0,
   SCH_COLLATION_CHARACTER_SET_APPLICABILITY,
   SCH_COLUMNS,
   SCH_GLOBAL_STATUS,

=== modified file 'drizzled/info_schema.h'
--- drizzled/info_schema.h	2009-06-27 16:01:28 +0000
+++ drizzled/info_schema.h	2009-06-27 16:33:55 +0000
@@ -199,15 +199,6 @@
                         InfoSchemaTable *schema_table) const;
 };
 
-class CharSetISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int fillTable(Session *session, 
-                        TableList *tables,
-                        COND *cond);
-  virtual int oldFormat(Session *session, InfoSchemaTable *schema_table) const;
-};
-
 class CollationISMethods : public InfoSchemaMethods
 {
 public:

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-06-27 16:13:04 +0000
+++ drizzled/show.cc	2009-06-27 16:33:55 +0000
@@ -97,7 +97,7 @@
       if (*wildstr == wild_prefix && wildstr[1])
         wildstr++;
       if (my_toupper(cs, *wildstr++) != my_toupper(cs, *str++))
-        return(1);
+        return (1);
     }
     if (! *wildstr )
       return (*str != 0);
@@ -108,26 +108,26 @@
     }
     else
     {						/* Found '*' */
-      if (!*wildstr)
-        return(0);		/* '*' as last char: OK */
+      if (! *wildstr)
+        return (0);		/* '*' as last char: OK */
       flag=(*wildstr != wild_many && *wildstr != wild_one);
       do
       {
-	if (flag)
-	{
-	  char cmp;
-	  if ((cmp= *wildstr) == wild_prefix && wildstr[1])
-	    cmp=wildstr[1];
-	  cmp=my_toupper(cs, cmp);
-	  while (*str && my_toupper(cs, *str) != cmp)
-	    str++;
-    if (!*str)
+        if (flag)
+        {
+          char cmp;
+          if ((cmp= *wildstr) == wild_prefix && wildstr[1])
+            cmp= wildstr[1];
+          cmp= my_toupper(cs, cmp);
+          while (*str && my_toupper(cs, *str) != cmp)
+            str++;
+          if (! *str)
+            return (1);
+        }
+        if (wild_case_compare(cs, str, wildstr) == 0)
+          return (0);
+      } while (*str++);
       return (1);
-	}
-  if (wild_case_compare(cs, str,wildstr) == 0)
-      return (0);
-      } while (*str++);
-      return(1);
     }
   }
   return (*str != '\0');
@@ -2955,39 +2955,6 @@
   return(0);
 }
 
-
-
-int CharSetISMethods::fillTable(Session *session, TableList *tables, COND *)
-{
-  CHARSET_INFO **cs;
-  const char *wild= session->lex->wild ? session->lex->wild->ptr() : NULL;
-  Table *table= tables->table;
-  const CHARSET_INFO * const scs= system_charset_info;
-
-  for (cs= all_charsets ; cs < all_charsets+255 ; cs++)
-  {
-    const CHARSET_INFO * const tmp_cs= cs[0];
-    if (tmp_cs && (tmp_cs->state & MY_CS_PRIMARY) &&
-        (tmp_cs->state & MY_CS_AVAILABLE) &&
-        !(tmp_cs->state & MY_CS_HIDDEN) &&
-        !(wild && wild[0] &&
-          wild_case_compare(scs, tmp_cs->csname,wild)))
-    {
-      const char *comment;
-      table->restoreRecordAsDefault();
-      table->field[0]->store(tmp_cs->csname, strlen(tmp_cs->csname), scs);
-      table->field[1]->store(tmp_cs->name, strlen(tmp_cs->name), scs);
-      comment= tmp_cs->comment ? tmp_cs->comment : "";
-      table->field[2]->store(comment, strlen(comment), scs);
-      table->field[3]->store((int64_t) tmp_cs->mbmaxlen, true);
-      if (schema_table_store_record(session, table))
-        return 1;
-    }
-  }
-  return 0;
-}
-
-
 int CollationISMethods::fillTable(Session *session, TableList *tables, COND *)
 {
   CHARSET_INFO **cs;
@@ -3799,33 +3766,6 @@
 }
 
 
-int CharSetISMethods::oldFormat(Session *session, InfoSchemaTable *schema_table)
-  const
-{
-  int fields_arr[]= {0, 2, 1, 3, -1};
-  int *field_num= fields_arr;
-  const InfoSchemaTable::Columns columns= schema_table->getColumns();
-  const ColumnInfo *column;
-  Name_resolution_context *context= &session->lex->select_lex.context;
-
-  for (; *field_num >= 0; field_num++)
-  {
-    column= columns[*field_num];
-    Item_field *field= new Item_field(context,
-                                      NULL, NULL, column->getName().c_str());
-    if (field)
-    {
-      field->set_name(column->getOldName().c_str(),
-                      column->getOldName().length(),
-                      system_charset_info);
-      if (session->add_item_to_list(field))
-        return 1;
-    }
-  }
-  return 0;
-}
-
-
 /*
   Create information_schema table
 
@@ -4092,19 +4032,6 @@
 };
 
 
-ColumnInfo charsets_fields_info[]=
-{
-  ColumnInfo("CHARACTER_SET_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 0, "Charset",
-   SKIP_OPEN_TABLE),
-  ColumnInfo("DEFAULT_COLLATE_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 0, "Default collation",
-   SKIP_OPEN_TABLE),
-  ColumnInfo("DESCRIPTION", 60, DRIZZLE_TYPE_VARCHAR, 0, 0, "Description",
-   SKIP_OPEN_TABLE),
-  ColumnInfo("MAXLEN", 3, DRIZZLE_TYPE_LONGLONG, 0, 0, "Maxlen", SKIP_OPEN_TABLE),
-  ColumnInfo()
-};
-
-
 ColumnInfo collation_fields_info[]=
 {
   ColumnInfo("COLLATION_NAME", 64, DRIZZLE_TYPE_VARCHAR, 0, 0, "Collation", SKIP_OPEN_TABLE),
@@ -4259,7 +4186,6 @@
   ColumnInfo()
 };
 
-static CharSetISMethods char_set_methods;
 static CollationISMethods collations_methods;
 static CollCharISMethods coll_char_methods;
 static ColumnsISMethods columns_methods;
@@ -4275,10 +4201,6 @@
 static TabConstraintsISMethods tab_constraints_methods;
 static TabNamesISMethods tab_names_methods;
 
-static InfoSchemaTable char_set_table("CHARACTER_SETS",
-                                      charsets_fields_info,
-                                      -1, -1, false, false, 0,
-                                      &char_set_methods);
 static InfoSchemaTable collations_table("COLLATIONS",
                                         collation_fields_info,
                                         -1, -1, false, false, 0,
@@ -4361,7 +4283,6 @@
 
 InfoSchemaTable schema_tables[]=
 {
-  char_set_table,
   collations_table,
   coll_char_set_table,
   columns_table,

=== modified file 'drizzled/show.h'
--- drizzled/show.h	2009-06-17 05:04:46 +0000
+++ drizzled/show.h	2009-06-21 22:22:05 +0000
@@ -58,6 +58,8 @@
 bool schema_table_store_record(Session *session, Table *table);
 
 int get_quote_char_for_identifier();
+int wild_case_compare(const CHARSET_INFO * const cs, 
+                      const char *str,const char *wildstr);
 
 InfoSchemaTable *find_schema_table(const char* table_name);
 InfoSchemaTable *get_schema_table(enum enum_schema_tables schema_table_idx);

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2009-06-26 06:25:57 +0000
+++ drizzled/sql_parse.cc	2009-06-27 16:33:55 +0000
@@ -382,7 +382,6 @@
   case SCH_OPEN_TABLES:
   case SCH_VARIABLES:
   case SCH_STATUS:
-  case SCH_CHARSETS:
   case SCH_COLLATIONS:
   case SCH_COLLATION_CHARACTER_SET_APPLICABILITY:
   case SCH_TABLE_CONSTRAINTS:

=== modified file 'plugin/info_schema/info_schema.cc'
--- plugin/info_schema/info_schema.cc	2009-06-21 17:33:10 +0000
+++ plugin/info_schema/info_schema.cc	2009-06-21 22:22:05 +0000
@@ -35,16 +35,19 @@
 /*
  * Vectors of columns for various I_S tables.
  */
+static vector<const ColumnInfo *> char_set_columns;
 static vector<const ColumnInfo *> processlist_columns;
 
 /*
  * Methods for various I_S tables.
  */
+static InfoSchemaMethods *char_set_methods= NULL;
 static InfoSchemaMethods *processlist_methods= NULL;
 
 /*
  * I_S tables.
  */
+static InfoSchemaTable *char_set_table= NULL;
 static InfoSchemaTable *processlist_table= NULL;
 
 /**
@@ -54,6 +57,7 @@
  */
 bool initTableColumns()
 {
+  createCharSetColumns(char_set_columns);
   createProcessListColumns(processlist_columns);
 
   return false;
@@ -64,6 +68,7 @@
  */
 void cleanupTableColumns()
 {
+  clearColumns(char_set_columns);
   clearColumns(processlist_columns);
 }
 
@@ -74,6 +79,7 @@
  */
 bool initTableMethods()
 {
+  char_set_methods= new CharSetISMethods();
   processlist_methods= new ProcessListISMethods();
 
   return false;
@@ -84,6 +90,7 @@
  */
 void cleanupTableMethods()
 {
+  delete char_set_methods;
   delete processlist_methods;
 }
 
@@ -95,6 +102,11 @@
 bool initTables()
 {
 
+  char_set_table= new InfoSchemaTable("CHARACTER_SETS",
+                                      char_set_columns,
+                                      -1, -1, false, false, 0,
+                                      char_set_methods);
+
   processlist_table= new InfoSchemaTable("PROCESSLIST",
                                          processlist_columns,
                                          -1, -1, false, false, 0,
@@ -108,6 +120,7 @@
  */
 void cleanupTables()
 {
+  delete char_set_table;
   delete processlist_table;
 }
 
@@ -136,6 +149,7 @@
     return 1;
   }
 
+  registry.add(char_set_table);
   registry.add(processlist_table);
 
   return 0;
@@ -149,6 +163,7 @@
  */
 int infoSchemaDone(PluginRegistry& registry)
 {
+  registry.remove(char_set_table);
   registry.remove(processlist_table);
 
   cleanupTableMethods();

=== modified file 'plugin/info_schema/info_schema_columns.cc'
--- plugin/info_schema/info_schema_columns.cc	2009-06-21 17:33:10 +0000
+++ plugin/info_schema/info_schema_columns.cc	2009-06-21 22:22:05 +0000
@@ -34,6 +34,49 @@
 
 using namespace std;
 
+void createCharSetColumns(vector<const ColumnInfo *>& cols)
+{
+  /*
+   * Create each column for the CHARACTER_SET table.
+   */
+  const ColumnInfo *name_col= new ColumnInfo("CHARACTER_SET_NAME",
+                                             64,
+                                             DRIZZLE_TYPE_VARCHAR,
+                                             0,
+                                             0,
+                                             "Charset",
+                                             SKIP_OPEN_TABLE);
+  const ColumnInfo *collate_col= new ColumnInfo("DEFAULT_COLLATE_NAME",
+                                                64,
+                                                DRIZZLE_TYPE_VARCHAR,
+                                                0,
+                                                0,
+                                                "Default collation",
+                                                SKIP_OPEN_TABLE);
+  const ColumnInfo *descrip_col= new ColumnInfo("DESCRIPTION",
+                                                60,
+                                                DRIZZLE_TYPE_VARCHAR,
+                                                0,
+                                                0,
+                                                "Description",
+                                                SKIP_OPEN_TABLE);
+  const ColumnInfo *len_col= new ColumnInfo("MAXLEN",
+                                            3,
+                                            DRIZZLE_TYPE_LONGLONG,
+                                            0,
+                                            0,
+                                            "Maxlen",
+                                            SKIP_OPEN_TABLE);
+
+  /*
+   * Add the columns to the vector.
+   */
+  cols.push_back(name_col);
+  cols.push_back(collate_col);
+  cols.push_back(descrip_col);
+  cols.push_back(len_col);
+}
+
 void createProcessListColumns(vector<const ColumnInfo *>& cols)
 {
   /*

=== modified file 'plugin/info_schema/info_schema_columns.h'
--- plugin/info_schema/info_schema_columns.h	2009-06-21 16:34:23 +0000
+++ plugin/info_schema/info_schema_columns.h	2009-06-21 22:22:05 +0000
@@ -24,6 +24,14 @@
 #include "drizzled/info_schema.h"
 
 /**
+ * Create the various volumns for the CHARACTER_SET I_S table and add them
+ * to the std::vector of columns for the CHARACTER_SET table.
+ *
+ * @param[out] cols vector to add columns to
+ */
+void createCharSetColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
  * Create the various volumns for the PROCESSLIST I_S table and add them
  * to the std::vector of columns for the PROCESSLIST table.
  *

=== modified file 'plugin/info_schema/info_schema_methods.cc'
--- plugin/info_schema/info_schema_methods.cc	2009-06-21 16:34:23 +0000
+++ plugin/info_schema/info_schema_methods.cc	2009-06-21 22:22:05 +0000
@@ -31,6 +31,61 @@
 
 using namespace std;
 
+int CharSetISMethods::fillTable(Session *session, TableList *tables, COND *)
+{
+  CHARSET_INFO **cs;
+  const char *wild= session->lex->wild ? session->lex->wild->ptr() : NULL;
+  Table *table= tables->table;
+  const CHARSET_INFO * const scs= system_charset_info;
+
+  for (cs= all_charsets ; cs < all_charsets+255 ; cs++)
+  {
+    const CHARSET_INFO * const tmp_cs= cs[0];
+    if (tmp_cs && (tmp_cs->state & MY_CS_PRIMARY) &&
+        (tmp_cs->state & MY_CS_AVAILABLE) &&
+        !(tmp_cs->state & MY_CS_HIDDEN) &&
+        !(wild && wild[0] &&
+          wild_case_compare(scs, tmp_cs->csname,wild)))
+    {
+      const char *comment;
+      table->restoreRecordAsDefault();
+      table->field[0]->store(tmp_cs->csname, strlen(tmp_cs->csname), scs);
+      table->field[1]->store(tmp_cs->name, strlen(tmp_cs->name), scs);
+      comment= tmp_cs->comment ? tmp_cs->comment : "";
+      table->field[2]->store(comment, strlen(comment), scs);
+      table->field[3]->store((int64_t) tmp_cs->mbmaxlen, true);
+      if (schema_table_store_record(session, table))
+        return 1;
+    }
+  }
+  return 0;
+}
+
+int CharSetISMethods::oldFormat(Session *session, InfoSchemaTable *schema_table)
+  const
+{
+  int fields_arr[]= {0, 2, 1, 3, -1};
+  int *field_num= fields_arr;
+  const ColumnInfo *column;
+  Name_resolution_context *context= &session->lex->select_lex.context;
+
+  for (; *field_num >= 0; field_num++)
+  {
+    column= schema_table->getSpecificColumn(*field_num);
+    Item_field *field= new Item_field(context,
+                                      NULL, NULL, column->getName());
+    if (field)
+    {
+      field->set_name(column->getOldName(),
+                      strlen(column->getOldName()),
+                      system_charset_info);
+      if (session->add_item_to_list(field))
+        return 1;
+    }
+  }
+  return 0;
+}
+
 int ProcessListISMethods::fillTable(Session* session, TableList* tables, COND*)
 {
   Table *table= tables->table;

=== modified file 'plugin/info_schema/info_schema_methods.h'
--- plugin/info_schema/info_schema_methods.h	2009-06-21 16:34:23 +0000
+++ plugin/info_schema/info_schema_methods.h	2009-06-21 22:22:05 +0000
@@ -25,6 +25,23 @@
 
 /**
  * @class
+ *   CharSetISMethods
+ * @brief
+ *   Class which implements any methods that the 
+ *   CHARACTER_SET I_S table needs besides the default
+ *   methods.
+ */
+class CharSetISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int fillTable(Session *session, 
+                        TableList *tables,
+                        COND *cond);
+  virtual int oldFormat(Session *session, InfoSchemaTable *schema_table) const;
+};
+
+/**
+ * @class
  *   ProcessListISMethods
  * @brief
  *   Class which implements any methods that the PROCESSLIST

